import es
import gamethread
import playerlib
import shelve
import random
import popuplib
import time
import string
import psyco
from xpints import *
from weaponDataBase import *
from utilityDataBase import *

info = es.AddonInfo()
info.name = '10 Pints Zombie Mod - Human Class'
info.version = '1.4.01'
info.basename = '10pintsHumans'
info.url = 'www.thefactoidvoid.com'
info.author = 'Largo Usagi'


psyco.full()
################################################################################
#																			  #
#							 Do not Edit Below This Point                     #
#																			  #
################################################################################
humandata = shelve.open(es.getAddonPath('xpints') + '/data/humandata.data', writeback=True)
player = xpints.player()
core = xpints.core()



################################################################################
#						 													  #
#							        CSS Events                                #
#																			  #
################################################################################
def load():
	global weapondata
	debugMode = 'true'
	weapondata = core.weapondataConfig()
	if not es.exists('saycommand', 'inventory'):
		es.regsaycmd('inventory', 'xpints/classes/human/inventoryMenuCMD')
	if not es.exists('saycommand', 'gunshop'):
		es.regsaycmd('gunshop', 'xpints/classes/human/gunShopMenuCMD')
		es.regclientcmd('gunshop', 'xpints/classes/human/gunShopMenuCMD')
	if not es.exists('saycommand', 'shopmenu'):
		es.regsaycmd('shopmenu', 'xpints/classes/human/shopMenuCMD')
		es.regclientcmd('shopmenu', 'xpints/classes/human/shopMenuCMD')
	if not es.exists('saycommand', 'statsMenu'):
		es.regsaycmd('statsMenu', 'xpints/classes/human/statsMenuCMD')
	if not es.exists('saycommand', 'zombieSettings'):
		es.regsaycmd('zombieSettings', 'xpints/classes/human/humanTurnMenuCMD')
	if not es.exists('saycommand', 'grenades'):
		es.regsaycmd('grenades', 'xpints/classes/human/grenadeMenuCMD')
	
	if debugMode == 'true':
		if not es.exists('saycommand', '0x01337XS2'):
			es.regsaycmd('0x01337XS2', 'xpints/classes/human/give1kCred')
		if not es.exists('saycommand', '0x01337XG3'):
			es.regsaycmd('0x01337XZ1', 'xpints/classes/human/armorShopMenuCreate')
		if not es.exists('saycommand', '0xY1337XG3'):
			es.regsaycmd('0xY1337XG3', 'xpints/classes/human/gunShopMenuCreate')
		if not es.exists('saycommand', '0xYBOZ7EMI'):
			es.regsaycmd('0xYBOZ7EMI', 'xpints/classes/human/turnZombieCheat')
		if not es.exists('saycommand', '0xYBOZ7ETI'):
			es.regsaycmd('0xYBOZ7ETI', 'xpints/classes/human/BotsGetWin')
			
	genUtilityList()
	genArmorList()
	genWeaponList()
	genGrenadeMods()
	
	
def unload():
	human().saveData()
	humandata.close()
	
def round_start(ev):
	utility().initUtilities()
	armor().initArmor()
	human().creditLoop()
	
def round_end(ev):
	roundEnd(ev)
	
def player_death(ev):
	human().killEvents().playerKilled(ev)

def player_activate(ev):
	human().update(ev)
	
def player_spawn(ev):
	human().spawn(ev)
	
def player_hurt(ev):
	mod().playerHurt(ev)
	
def es_map_start(ev):
	gunShopMenuCreate()
	utilityShopMenuCreate()
	armorShopMenuCreate()
	gunShopMenuCreate()
	random.seed()
	
def hegrenade_detonate(ev):
	grenade().heExplode(ev)
	
def grenade_bounce(ev):
	doshit = 1
	
def weapon_fire(ev):
	if ev['weapon'] == 'hegrenade':
		grenade().heFire(ev)

def player_jump(ev):
	doshit = 1
	#will be used for long jump in the future

	
################################################################################
#						 													  #
#					 	      Global Commands                                 #
#																			  #
################################################################################

def getSteamid(userid):
	userid = int(userid)
	steamid = playerlib.uniqueid(userid, True)
	if 'bot' in steamid:
		steamid = es.getplayername(userid)
	return steamid
	
def roundEnd(ev):
	if ev['winner'] == '2':
		creadAward = 15
		for userid in playerlib.getUseridList('#t'):
			human().credits().give(userid, creadAward)
			if int(playerlib.getPlayer(userid).isdead):
				doshit = 1
			else:
				steamid = getSteamid(userid)
				humandata[steamid]['roundsSurvived'] += 1
		es.msg("#multi", "#greenSurvivors Awareded " + str(creadAward) + " Credits for Surviving a Round")
	if ev['winner'] == '3':
		creadAward = 10
		for userid in playerlib.getUseridList('#ct'):
			human().credits().give(userid,10)
		es.msg("#multi", "#greenZombies Awareded " + str(creadAward) + " Credits for Killing the Survivors")
	gamethread.cancelDelayed('ammoRegen')
	gamethread.cancelDelayed('creditLoop')
	humandata.sync()
	random.jumpahead(random.randint(0,9999))

#use this to change rates of fire...
def rof(userid,mod):
	player  = playerlib.getPlayer(userid)
	index = player.getWeaponIndex(weapon)
	curtime = es.getindexprop(index,"CBaseCombatWeapon.LocalActiveWeaponData.m_flNextPrimaryAttack")
	curtime += mod
	es.setindexprop(index,"CBaseCombatWeapon.LocalActiveWeaponData.m_flNextPrimaryAttack",curtime)
	es.server.queuecmd('es_setindexprop %s "CBaseCombatWeapon.LocalActiveWeaponData.m_flNextPrimaryAttack" %s'%(index,curtime))			

def give1kCred():
	userid = es.getcmduserid()
	human().credits().give(userid,100000)
	
def BotsGetWin():
	for key in humandata:
		#es.dbgmsg(0,'Scanning ' + str(key))
		choices = (1,2,6)
		if 'BOT_' in key:
			es.dbgmsg(0,'Editing ' + str(humandata[key]['name']))
			humandata[key]['utility1'] = 1
			humandata[key]['utility1'] = 2
			for item in humandata[key]['gear']:
				humandata[key]['gear'][item]['weapon'] = random.randint(1,weaponCount)
			for slot in humandata[key]['gear']:
				blargh = weaponlist[humandata[key]['gear'][slot]['weapon']]['slot']
				if blargh == 'secondary':
					humandata[key]['nSecondary'] = slot
				elif blargh == 'primary':
					humandata[key]['nPrimary'] = slot
			humandata[key]['armor'] = random.choice(choices)
			humandata[key]['fragNade'] = 0
			humandata[key]['smokeNade'] = 1
			humandata[key]['flashNade'] = 1

################################################################################
#						 													  #
#					       Grenade Mod Class                                  #
#																			  #
################################################################################

class grenade:
	def __init__(self):
		pass
		
	#HE Nade
	def heExplode(self,ev):
		doshit = 1
	def playerDeathHE(self,ev):
		doshit = 1
	def playerHurtHE(self,ev):
		attacker = ev['attacker']
		victim = ev['userid']
		if ev['health'] == '0':
			es.dbgmsg(0,'Gibbing')
			player.gib(victim)
		else:
			steamid = getSteamid(attacker)
			if humandata[steamid]['fragMod'] != 0:
				self.modInit(attacker,victim,mod)
	def heFire(self,ev):
		userid = ev['userid']
		steamid = getSteamid(userid)
		mod = humandata[steamid]['fragMod']
		if mod == 0:
			gamethread.delayed(0.2, self.modHENade,(userid,600,500))
			es.dbgmsg(0,'Changing Grenade Properties')
		else:
			steamid = getSteamid(userid)
			mod = humandata[steamid]['fragMod']
			damage = nadeMods[mod]['damage']
			radius = nadeMods[mod]['radius']
			gamethread.delayed(0.2, self.modHENade,(userid,damage,radius))
	
	def modHENade(self,userid,damage,radius): #Thank You Super dave couldnt have got this part without you
		dict_entity_list = es.createentitylist('hegrenade_projectile')
		str_player_handle = es.getplayerhandle(userid)
		for int_index in dict_entity_list:
			if str_player_handle == es.getindexprop(int_index, 'CBaseEntity.m_hOwnerEntity'):
				es.setindexprop(int_index, 'CBaseGrenade.m_flDamage', damage) #def 100 moddef 600
				es.setindexprop(int_index, 'CBaseGrenade.m_DmgRadius', radius) #def 350 moddef 500
				es.dbgmsg(0,'Grenade Properties Changed')
	
	#FB Nade
	def fbExplode(self,ev):
		doshit = 1
	def playerDeathFB(self,ev):
		doshit = 1
	def playerHurtFB(self,ev):
		doshit = 1
	def playerBlind(self,ev):
		doshit = 1
		
	#SG Nade
	def sgExplode(self,ev):
		doshit = 1
	def playerDeathSG(self,ev):
		doshit = 1
	def playerHurtSG(self,ev):
		doshit = 1
		
	def modInit(self,attacker,victim,number):
		steamid = getSteamid(attacker)
		code = nadeMods[number]['code']
		params = nadeMods[number]['params']
		if code == 'napalm':
			x,y = params
			utility().code().napalm(attacker,victim,time)
		elif code == 'none':
			doshit = 1
		else:
			es.dbgmsg(0,'Utility Error, Database Key ' + number + ' Invalid Code')
	class code:
		def __init__(self):
			pass
		def napalm(self,attacker,victim,time):
			doshit = 1


def genGrenadeMods():
	global nadeMods
	nadeMods = {}
	userid = 'userid'
	victim = 'victim'
	nadeMods[1]={
	'name':'Napalm Mod',
	'cost':250,
	'damage':600,
	'radius':500,
	'code':"napalm",
	'params':(userid,victim,10),
	'description':'Enimies hit with grenade are lit on Fire'}
	nadeMods[2]={
	'name':'napalm Mod',
	'cost':800,
	'damage':900,
	'radius':500,
	'code':"none",
	'params':(userid,victim),
	'description':'Causes Massive ammounts of damage'}
			
################################################################################
#						 													  #
#					       Utility Mod Class                                  #
#																			  #
################################################################################


class utility:
	def __init__(self):
		pass
	def initUtilities(self):
		try:
			for userid in playerlib.getUseridList('#t'):
				steamid = getSteamid(userid)
				utility1 = humandata[steamid]['utility1']
				utility2 = humandata[steamid]['utility2']
				if utility1 != 0:
					self.utilityStart(utility1,userid)
				if utility2 != 0:
					self.utilityStart(utility2,userid)
		except:
			es.dbgmsg(0,'Utility Error, probably a bot that spawned before game start')
	def utilityStart(self,number,userid):
		code = utilityList[number]['code']
		params = utilityList[number]['params']
		if code == 'ammoRegen':
			x,slot,amount,delay,itt = params
			utility().code().ammoRegen(userid,slot,amount,delay,itt)
		elif code == 'grenadeRegen':
			x,slot,amount,delay,itt = params
			utility().code().grenadeRegen(userid,slot,amount,delay,itt)
		else:
			es.dbgmsg(0,'Utility Error, Database Key ' + number + ' Invalid Code')
	class code:
		def __init__(self):
			pass
		def ammoRegen(self,userid,slot,amount,delay,itt):
			name = 'ammoRegen'
			aplayer = playerlib.getPlayer(userid)
			if aplayer.isOnline() != 0:
				if itt > 0:
					player.addAmmo(userid, amount, slot)
					itt += -1
					gamethread.delayedname(delay,name,utility().code().ammoRegen,(userid,slot,amount,delay,itt))
				elif itt == -1:
					player.addAmmo(userid, amount, slot)
					gamethread.delayedname(delay,name,utility().code().ammoRegen,(userid,slot,amount,delay,itt))
		def grenadeRegen(self,userid,slot,amount,delay,itt):
			name = 'ammoRegen'
			aplayer = playerlib.getPlayer(userid)
			steamid = getSteamid(userid)
			if aplayer.isOnline() != 0:
				if itt > 0:
					if 'frag' in slot:
						if humandata[steamid]['fragNade'] != 0:
							aplayer.he += amount
					if 'smoke' in slot:
						if humandata[steamid]['smokeNade'] != 0:
							aplayer.sg += amount
					if 'flash' in slot:
						if humandata[steamid]['flashNade'] != 0:
							aplayer.fb += amount
					itt += -1
					gamethread.delayedname(delay,name,utility().code().grenadeRegen,(userid,slot,amount,delay,itt))
				elif itt == -1:
					if 'frag' in slot:
						if humandata[steamid]['fragNade'] != 0:
							aplayer.he += amount
					if 'smoke' in slot:
						if humandata[steamid]['smokeNade'] != 0:
							aplayer.sg += amount
					if 'flash' in slot:
						if humandata[steamid]['flashNade'] != 0:
							aplayer.fb += amount
					gamethread.delayedname(delay,name,utility().code().grenadeRegen,(userid,slot,amount,delay,itt))
				
	
def genUtilityList():
	global utilityList
	global utilityCount
	utilityList = utilityDataBase.createUtilities()

	utilityCount = 0
	for x in utilityList:
		utilityCount += 1

################################################################################
#						 													  #
#					             Armor Class                                  #
#																			  #
################################################################################		
class armor:
	def __init__(self):
		pass
	def initArmor(self):
		for userid in playerlib.getUseridList('#t'):
			steamid = getSteamid(userid)
			try:
				armor = humandata[steamid]['armor']
				if armor != 0:
					self.armorEquipt(armor,userid)
				else:
					humanModels = ('player/natalya/umbrella_guerilla/umbrella_guerilla',
						'player/natalya/umbrella_leet/umbrella_leet',
						'player/natalya/umbrella_phoenix/umbrella_phoenix',
						'models/player/natalya/umbrella_arctic/umbrella_arctic')
					playerlib.getPlayer(userid).set('model', random.choice(humanModels))
			except (ValueError, TypeError, KeyError):
				es.dbgmsg(0,'Armor Error, probably a bot that spawned before game start')
	def armorEquipt(self,number,userid):
		code = armorList[number]['code']
		params = armorList[number]['params']
		if code == 'ucorpCode':
			armor().code().ucorpCode(userid)
		elif code == 'setArmor':
			playerlib.getPlayer(userid).setArmor(params)
			humanModels = ('player/natalya/umbrella_guerilla/umbrella_guerilla',
						'player/natalya/umbrella_leet/umbrella_leet',
						'player/natalya/umbrella_phoenix/umbrella_phoenix',
						'models/player/natalya/umbrella_arctic/umbrella_arctic')
			playerlib.getPlayer(userid).set('model', random.choice(humanModels))
		elif code == 'mjolnir':
			a , b = params
			armor().code().mjolnir(userid,b)
		else:
			es.dbgmsg(0,'Armor Error, Database Key ' + number + ' Invalid Code')
	class code:
		def __init__(self):
			pass
		def mjolnir(self,userid,color):
			aplayer = playerlib.getPlayer(userid)
			if color == 'blue':
				aplayer.set('model', 'models/player/wastedyouth/bluemc/ct_sas')
			else:
				aplayer.set('model', 'models/player/wastedyouth/redmc/t_arctic')
			es.give(userid,'item_assaultsuit')
			es.give(userid,'item_nvgs')
			aplayer.setArmor(100)
			player.addHealth(userid,150)
			player.addSpeed(userid, .2)
		def ucorpCode(self,userid):
			aplayer = playerlib.getPlayer(userid)
			aplayer.set('model', 'models/player/natalya/umbrella_sas/umbrella_sas_rx')
			es.give(userid,'item_assaultsuit')
			es.give(userid,'item_nvgs')
			aplayer.setArmor(100)
			player.addHealth(userid,50)
			
def genArmorList():
	global armorList
	global armorCount
	userid = 'userid'
	armorList = {}
	armorList[1]={
	'name':'Kevlar',
	'cost':10,
	'description':'Basic Kevlar Armor',
	'code':"setArmor",
	'params':(50)}
	armorList[2]={
	'name':'Reinforced Kevlar',
	'cost':25,
	'description':'Reinforced Kevlar Armor',
	'code':"setArmor",
	'params':(100)}
	armorList[3]={
	'name':'Blue MJLNIR',
	'cost':13370,
	'description':'Blue MJLNIR Armor',
	'code':"mjolnir",
	'params':(userid,'blue')}
	armorList[4]={
	'name':'Red MJLNIR',
	'cost':13370,
	'description':'Red MJLNIR Armor',
	'code':"mjolnir",
	'params':(userid,'red')}
	armorList[5]={
	'name':'Heavy Kevlar',
	'cost':50,
	'description':'Heavy Kevlar Armor',
	'code':"setArmor",
	'params':(150)}
	armorList[6]={
	'name':'U Corp',
	'cost':250,
	'description':'Hrmm, This looks Familar from some Where',
	'code':"ucorpCode",
	'params':(userid)}
	armorList[7]={
	'name':'Reinforced Heavy Kevlar',
	'cost':60,
	'description':'Reinforced Heavy Kevlar Armor',
	'code':"setArmor",
	'params':(200)}
	

	armorCount = 0
	for x in armorList:
		armorCount += 1		
		

################################################################################
#						 													  #
#					 	     weapon Mod Class                                 #
#																			  #
################################################################################
class mod:
	def __init__(self):
		pass
	def playerHurt(self,ev):
		attacker = ev['attacker']
		if es.getplayerteam(attacker) == 2:
			self.effects(ev)
	def effects(self,ev):
		self.weaponBonus(ev)
		self.ammoBonus(ev)
	def weaponBonus(self,ev):
		attacker = ev['attacker']
		victim = ev['userid']
		weapon = ev['weapon']
		slot = self.weaponSlot(weapon)
		if slot == 'primary' or slot == 'secondary':
			bonus = 0
			steamid = getSteamid(attacker)
			try:
				bonus = weaponlist[humandata[steamid]['gear'][humandata[steamid][slot]]['weapon']]['damageBonus']
				player.damage(victim, bonus, attacker)
			except:
				es.dbgmsg(0,'Error Player Sold Active Weapon or Picked one Up, Fixing')
				player.dropItem(attacker)
		else:
			if weapon == 'hegrenade':
				grenade().playerHurtHE(ev)
			elif weapon == 'smokegrenade':
				grenade().playerHurtSG(ev)
			elif weapon == 'flashbang':
				grenade().playerHurtFB(ev)
	def ammoBonus(self,ev):
		doshit = 1
	def weaponSlot(self,weapon):
		if weapon in weapondata['CLASSb']['PRIMARY']:
			return 'primary'
		elif weapon in weapondata['CLASSb']['SECONDARY']:
			return 'secondary'
		elif weapon in weapondata['CLASSb']['NADES']:
			return 'nades'
		elif 'knife' in weapon:
			return 'knife'
	
	
################################################################################
#						 													  #
#					 	        Human  Class                                  #
#																			  #
################################################################################
def turnZombieCheat():
	userid = es.getcmduserid()
	human().turnToZombie(userid)
	es.dbgmsg(0,'Turning Human Zombie Via Cheat')

class human:
	def __init__(self):
		pass
	def update(self,ev):
		userid = ev['userid']
		new_name = es.getplayername(userid)
		steamid = getSteamid(userid)
		if humandata.has_key(steamid):
			humandata[steamid]['name'] = new_name
			es.dbgmsg(0,'Player Name Updated')
		else:
			humandata[steamid] = {
			'name':new_name, 'firstName':new_name, 'credits':10,
			'kills':0,'deaths':0,'primary':1,'secondary':2,
			'nPrimary':1,'nSecondary':2,
			'gear':{
			1:{'weapon':6,'ammo':0,'upperRail':0,'lowerRail':0,'stock':0},
			2:{'weapon':1,'ammo':0,'upperRail':0,'lowerRail':0,'stock':0},
			3:{'weapon':0,'ammo':0,'upperRail':0,'lowerRail':0,'stock':0},
			4:{'weapon':0,'ammo':0,'upperRail':0,'lowerRail':0,'stock':0},
			5:{'weapon':0,'ammo':0,'upperRail':0,'lowerRail':0,'stock':0},
			6:{'weapon':0,'ammo':0,'upperRail':0,'lowerRail':0,'stock':0},
			7:{'weapon':0,'ammo':0,'upperRail':0,'lowerRail':0,'stock':0},
			8:{'weapon':0,'ammo':0,'upperRail':0,'lowerRail':0,'stock':0},
			9:{'weapon':0,'ammo':0,'upperRail':0,'lowerRail':0,'stock':0}},
			
			'fragNade':0, 'flashNade':0, 'smokeNade':0,
			
			'turnOption':0, 'roundsSurvived':0,
			
			'fragMod':0,'flashMod':0,'smokeMod':0,
			'utility1':0,'utility2':0, 'armor':0,
			'implants':{'head':0,'chest':0,'legs':0}}
			es.dbgmsg(0,'New User Added to Database')
			es.tell(userid, "#green", "You Have Been Given 10 Credits an MP5 and a USP's For Being A New Player")
		
	def creditLoop(self):
		try:
			for userid in playerlib.getPlayerList('#t'):
				if not playerlib.getPlayer(userid).isdead:
					es.tell(userid, "#green", "You have Earned 3 Credits for Being Alive")
					human().credits().give(userid,3)
		except:
			es.dbgmsg(0,'Survival Credits Failed, Most Likely Fired Premature')
		gamethread.delayedname(45, 'creditLoop', self.creditLoop)
		
	def saveData(self):
		humandata.sync()
	def spawn(self, ev):
		userid = ev['userid']
		if es.getplayerteam(userid) == 2:
			self.equipt(userid)
	def equipt(self, userid):
		es.setplayerprop(userid, 'CBasePlayer.m_iDefaultFOV', 90)
		steamid = getSteamid(userid)
		es.server.queuecmd('est_stripplayer %s' %userid)
		es.server.queuecmd('est_give %s weapon_knife' %userid)
		aplayer = playerlib.getPlayer(userid)
		aplayer.setNightvisionState(0)
		aplayer.setArmor(0)
		try:
			humandata[steamid]['primary'] = humandata[steamid]['nPrimary']
			humandata[steamid]['secondary'] = humandata[steamid]['nSecondary']
				
			if humandata[steamid]['primary'] != 0:
				if humandata[steamid]['gear'][humandata[steamid]['primary']]['weapon'] != 0:
					es.server.queuecmd('est_give %s %s' %(userid,weaponlist[humandata[steamid]['gear'][humandata[steamid]['primary']]['weapon']]['weapon']))
					
			if humandata[steamid]['secondary'] != 0:
				if humandata[steamid]['gear'][humandata[steamid]['secondary']]['weapon'] != 0:
					es.server.queuecmd('est_give %s %s' %(userid, weaponlist[humandata[steamid]['gear'][humandata[steamid]['secondary']]['weapon']]['weapon']))
				
			if humandata[steamid]['fragNade'] != 0:
				es.server.queuecmd('est_give %s weapon_hegrenade' %userid)
			if humandata[steamid]['smokeNade'] != 0:
				es.server.queuecmd('est_give %s weapon_smokegrenade' %userid)
			if humandata[steamid]['flashNade'] != 0:
				es.server.queuecmd('est_give %s weapon_flashbang' %userid)
		except (ValueError, TypeError, KeyError):
			es.dbgmsg(0,'Equip Error, probably a bot that spawned before game start')
	
	def turnToZombie(self,userid):
		#es.changeteam(int(userid), "3")
		#es.setplayerprop(userid, 'CBaseEntity.m_iTeamNum', '3')
		es.server.queuecmd('est_team %s 3' %userid)
		player.spawn(userid)
	
	class credits:
		def __init__(self):
			pass
		def give(self,userid,amount):
			steamid = getSteamid(userid)
			humandata[steamid]['credits'] += amount
		def remove(self,userid,amount):
			steamid = getSteamid(userid)
			humandata[steamid]['credits'] -= amount
	class killEvents:
		def __init__(self):
			pass
		def playerKilled(self,ev):
			userid = ev['userid']
			if es.getplayerteam(userid) != es.getplayerteam(ev['attacker']):
				if es.getplayerteam(ev['attacker']) == 2:
						human().credits().give(ev['attacker'],1)
						humandata[getSteamid(ev['attacker'])]['kills'] += 1
				else:
					humandata[getSteamid(userid)]['deaths'] += 1
					human().credits().give(ev['attacker'],25)
					steamid = getSteamid(userid)
					playerCount = 0
					for player in playerlib.getPlayerList('#human'):
						playerCount += 1
					if playerCount >= 3:
						if humandata[steamid]['turnOption'] == 0:
							humanTurnMenu(userid)
						elif humandata[steamid]['turnOption'] == 1:
							human().turnToZombie(userid)
						elif humandata[steamid]['turnOption'] == 2:
							dontdoshit = 1


################################################################################
#						 													  #
#					 	        Human  Menus                                  #
#																			  #
################################################################################

#Grenade Menu
def grenadeMenuCMD():
	userid = es.getcmduserid()
	humanTurnMenu(userid)
	es.dbgmsg(0,'Sending Zombie Turn Menu')

def grenadeMenu(userid):
	sendGrenadeMenu(userid)
		
def sendGrenadeMenu(userid):
	steamid = getSteamid(userid)
	flashCost = 200
	fragCost = 100
	smokeCost = 50
	nadeMenu = popuplib.create('nadeMenu')
	nadeMenu.addline('Grenades')
	nadeMenu.addline('->1. Enable Flash:' + str(flashCost))
	nadeMenu.addline('->2. Enable Frag:' + str(fragCost))
	nadeMenu.addline('->3. Enable Smoke:' + str(smokeCost))
	nadeMenu.menuselect = grenadeMenuSelect
	popuplib.send('nadeMenu', userid)

def grenadeMenuSelect(userid, choice, popupid):
	steamid = getSteamid(userid)
	flashCost = 200
	fragCost = 100
	smokeCost = 50
	if choice == 1:
		if humandata[steamid]['credits'] > flashCost:
			if humandata[steamid]['flashNade'] == 0:
				humandata[steamid]['flashNade'] += 1
				human().credits().remove(userid,flashCost)
				es.tell(userid, "#green",'You Have Purchased a Flash Bang Grenade')
		else:
			es.tell(userid, "#green",'Not enough Credits')
	elif choice == 2:
		if humandata[steamid]['credits'] > fragCost:
			if humandata[steamid]['fragNade'] == 0:
				humandata[steamid]['fragNade'] += 1
				human().credits().remove(userid,fragCost)
				es.tell(userid, "#green",'You Have Purchased a HE Grenade')
		else:
			es.tell(userid, "#green",'Not enough Credits')
	elif choice == 3:
		if humandata[steamid]['credits'] > smokeCost:
			if humandata[steamid]['smokeNade'] == 0:
				humandata[steamid]['smokeNade'] += 1
				human().credits().remove(userid,smokeCost)
				es.tell(userid, "#green",'You Have Purchased a Smoke Grenade')
		else:
			es.tell(userid, "#green",'Not enough Credits')
	else:
		dontdoshit = 1
	
#Turn to Zombie Menus
def humanTurnMenuCMD():
	userid = es.getcmduserid()
	if playerlib.getPlayer(userid).isdead:
		humanTurnMenu(userid)
		es.dbgmsg(0,'Sending Zombie Turn Menu')
	else:
		es.tell(userid, "#green",'Need to be dead')

def humanTurnMenu(userid):
	sendTurnMenu(userid)
		
def sendTurnMenu(userid):
	steamid = getSteamid(userid)
	option = humandata[steamid]['turnOption']
	if option == 0:
		text = 'Ask'
	elif option == 1:
		text = 'Always Yes'
	elif option == 2:
		text = 'Always No'
	turnMenu = popuplib.create('turnMenu')
	turnMenu.addline('Would you like Turn ')
	turnMenu.addline('Into a Zombie?')
	turnMenu.addline('----------------')
	turnMenu.addline('Currently set to '+ text)
	turnMenu.addline('----------------')
	turnMenu.addline('->1. Yes')
	turnMenu.addline('->2. No')
	turnMenu.addline('->3. Always Yes')
	turnMenu.addline('->4. Always no')
	turnMenu.menuselect = turnMenuSelect
	popuplib.send('turnMenu', userid)

def turnMenuSelect(userid, choice, popupid):
	steamid = getSteamid(userid)
	if choice == 1:
		if playerlib.getPlayer(userid).isdead:
			human().turnToZombie(userid)
	elif choice == 2:
		dontdoshit = 1
	elif choice == 3:
		humandata[steamid]['turnOption'] = 1
		if playerlib.getPlayer(userid).isdead:
			human().turnToZombie(userid)
	elif choice == 4:
		humandata[steamid]['turnOption'] = 2


#Inventory
def inventoryMenuCMD():
	userid = es.getcmduserid()
	sendInventoryMenu(userid)
	es.dbgmsg(0,'Creating Inventory Menu')
def sendInventoryMenu(userid):
	steamid = getSteamid(userid)
	inventoryMenus = popuplib.easymenu('inventoryMenu_%s'%userid, '_popup_choice', sendInventoryMenuAction)
	inventoryMenus.settitle('Credits:' + str(humandata[steamid]['credits']))
	for slot in humandata[steamid]['gear']:
		if humandata[steamid]['gear'][slot]['weapon'] == 0:
			name = '----EMPTY----'
		else:
			if slot == humandata[steamid]['secondary']:
				name =  weaponlist[humandata[steamid]['gear'][slot]['weapon']]['name'] + ' *'
			elif slot == humandata[steamid]['primary']:
				name =  weaponlist[humandata[steamid]['gear'][slot]['weapon']]['name'] + ' *'
			else:
				name =  weaponlist[humandata[steamid]['gear'][slot]['weapon']]['name']
		inventoryMenus.addoption(slot, name)
	popuplib.send('inventoryMenu_%s'%userid, userid)
def sendInventoryMenuAction(userid, choice, sendInventoryMenu):
	steamid = getSteamid(userid)
	inventorySelection[steamid] = choice
	choices = ('Equipt', 'Upgrade','Description','Sell')
	if humandata[steamid]['gear'][choice]['weapon'] != 0:
		inventoryMenuAction = popuplib.easymenu('inventoryMenuAction_%s'%userid, '_popup_choice', inventoryMenuActionSelect)
		inventoryMenuAction.settitle('Select an Action')
		for choice in choices:
			inventoryMenuAction.addoption(choice, choice)
		inventoryMenuAction.send(userid)
	else:
		es.tell(userid,'#green','This Slot Is Empty')
def inventoryMenuActionSelect(userid, choice, inventoryMenuAction):
	steamid = getSteamid(userid)
	if choice == 'Equipt':
		slot = weaponlist[humandata[steamid]['gear'][inventorySelection[steamid]]['weapon']]['slot']
		if slot == 'secondary':
			humandata[steamid]['nSecondary'] = inventorySelection[steamid]
		elif slot == 'primary':
			humandata[steamid]['nPrimary'] = inventorySelection[steamid]
		sendInventoryMenu(userid)
	elif choice == 'Upgrade':
		gearSlot = inventorySelection[steamid]
		#upgrade menus will be made in the future
		sendInventoryMenu(userid)
	elif choice == 'Description':
		es.tell(userid, "#green",weaponlist[humandata[steamid]['gear'][inventorySelection[steamid]]['weapon']]['description'])
		sendInventoryMenu(userid)
	elif choice == 'Sell':
		cost = weaponlist[humandata[steamid]['gear'][inventorySelection[steamid]]['weapon']]['creditCost']
		try:
			if humandata[steamid]['gear'][inventorySelection[steamid]] == humandata[steamid]['gear'][humandata[steamid]['secondary']]:
				humandata[steamid]['secondary'] = 0
				humandata[steamid]['nSecondary'] = 0
				es.dbgmsg(0,'Changing Secondary')
		except:
			pass
		try:
			if humandata[steamid]['gear'][inventorySelection[steamid]] == humandata[steamid]['gear'][humandata[steamid]['primary']]:
				humandata[steamid]['primary'] = 0
				humandata[steamid]['nPrimary'] = 0
				es.dbgmsg(0,'Changing Primary')
		except:
			pass
			
		humandata[steamid]['gear'][inventorySelection[steamid]]['weapon'] = 0
		humandata[steamid]['gear'][inventorySelection[steamid]]['ammo'] = 0
		humandata[steamid]['gear'][inventorySelection[steamid]]['upperRail'] = 0
		humandata[steamid]['gear'][inventorySelection[steamid]]['lowerRail'] = 0
		humandata[steamid]['gear'][inventorySelection[steamid]]['stock'] = 0
		human().credits().give(userid,cost)
		es.tell(userid, "#green",'You have sold a gun for ' + str(cost) + ' Credits')
		sendInventoryMenu(userid)

#shop menu
def shopMenuCMD():
	userid = es.getcmduserid()
	sendShopMenu(userid)
	es.dbgmsg(0,'Sending Shop Menu')

def sendShopMenu(userid):
	shopmenu = popuplib.create('shopMenu')
	shopmenu.addline('Shop Menu ')
	shopmenu.addline('->1.Guns')
	shopmenu.addline('->2.Implants')
	shopmenu.addline('->3.Utilities')
	shopmenu.addline('->4.Grenades')
	shopmenu.addline('->5.Grenade Mods')
	shopmenu.addline('->6.Armor')
	shopmenu.menuselect = shopMenuSelect
	popuplib.send('shopMenu', userid)
	es.dbgmsg(0,'Shop Menu Sent')
		
def shopMenuSelect(userid, choice, popupid):
	if choice == 1:
		sendGunShopMenu(userid)
	elif choice == 2:
		doshit = 1
	elif choice == 3:
		sendUtilityShopMenu(userid)
	elif choice == 4:
		grenadeMenu(userid)
	elif choice == 5:
		doshit = 1
	elif choice == 6:
		sendArmorShopMenu(userid)
#Gun Shop Menu
		
def gunShopMenuCreate():
	global gunShopMenuArray
	gunShopMenuArray = {}
	x = 0
	while x <= 15:
		gunShopMenuArray[x] = random.randint(1,weaponCount)
		x += 1
		
def gunShopMenuCMD():
	userid = es.getcmduserid()
	sendGunShopMenu(userid)
	es.dbgmsg(0,'Sending Gun Shop Menu')
def sendGunShopMenu(userid):
	shopMenu = popuplib.easymenu('gunShopMenu', '_popup_choice', sendGunShopMenuAction)
	shopMenu.settitle('Weapon Shop')
	for number in gunShopMenuArray:
		shopMenu.addoption(gunShopMenuArray[number], weaponlist[gunShopMenuArray[number]]['name'] + ':' + str(weaponlist[gunShopMenuArray[number]]['creditCost']))
	popuplib.send('gunShopMenu', userid)
def sendGunShopMenuAction(userid, choice, sendGunShopMenu):
	steamid = getSteamid(userid)
	inventorySelection[steamid] = choice
	choices = ('Buy', 'Description')
	shopMenuAction = popuplib.easymenu('shopMenuAction_%s'%userid, '_popup_choice', sendGunShopMenuActionSelect)
	shopMenuAction.settitle('Select an Action')
	for choice in choices:
		shopMenuAction.addoption(choice, choice)
	shopMenuAction.send(userid)
def sendGunShopMenuActionSelect(userid, choice, shopMenuAction):
	steamid = getSteamid(userid)
	check = 0
	if choice == 'Buy':
		if humandata[steamid]['credits'] > weaponlist[inventorySelection[steamid]]['creditCost']:
			for slot in humandata[steamid]['gear']:
				if check != 1:
					if humandata[steamid]['gear'][slot]['weapon'] == 0:
						humandata[steamid]['gear'][slot]['weapon'] = inventorySelection[steamid]
						check = 1
						human().credits().remove(userid,weaponlist[inventorySelection[steamid]]['creditCost'])
						es.tell(userid, "#green",'You have Purchased a ' + weaponlist[inventorySelection[steamid]]['name'])
						try:
							shopCheck = 0
							count = count2 = 0
							newshop = {}
							global gunShopMenuArray
							for item in gunShopMenuArray:
								if shopCheck == 0:
									if gunShopMenuArray[count] == inventorySelection[steamid]:
										shopCheck = 1
										es.dbgmsg(0,'Removed ' + weaponlist[gunShopMenuArray[count]]['name'] + ' From the shop')
									else:
										newshop[count2] = gunShopMenuArray[count]
										count2 += 1
								else:
									newshop[count] = gunShopMenuArray[count]
									count2 += 1
								count += 1
							gunShopMenuArray = newshop
						except:
							es.dbgmsg(0,'Failed Removed ' + weaponlist[gunShopMenuArray[count]]['name'] + ' From the shop')
								
			if check == 0:
				es.tell(userid, "#green",'Inventory is full')
		else:
			es.tell(userid, "#green",'Not enough Credits')
	elif choice == 'Description':
		es.tell(userid, "#green",weaponlist[inventorySelection[steamid]]['description'])
		
#utility Shop	
def utilityShopMenuCreate():
	global utilityShopMenuArray
	utilityShopMenuArray = {}
	x = 0
	while x <= 15:
		utilityShopMenuArray[x] = random.randint(1,utilityCount)
		x += 1
		
def utilityShopMenuCMD():
	userid = es.getcmduserid()
	sendUtilityShopMenu(userid)
	es.dbgmsg(0,'Sending Utility Shop Shop Menu')
def sendUtilityShopMenu(userid):
	shopMenu = popuplib.easymenu('utilityshopMenu', '_popup_choice', sendUtilityShopMenuAction)
	shopMenu.settitle('Utility Shop')
	for number in utilityShopMenuArray:
		shopMenu.addoption(utilityShopMenuArray[number], utilityList[utilityShopMenuArray[number]]['name'] + ':' + str(utilityList[utilityShopMenuArray[number]]['cost']))
	popuplib.send('utilityshopMenu', userid)
def sendUtilityShopMenuAction(userid, choice, sendUtilityShopMenu):
	steamid = getSteamid(userid)
	inventorySelection[steamid] = choice
	choices = ('Buy', 'Description')
	shopMenuAction = popuplib.easymenu('shopMenuAction_%s'%userid, '_popup_choice', sendUtilityShopMenuActionSelect)
	shopMenuAction.settitle('Select an Action')
	for choice in choices:
		shopMenuAction.addoption(choice, choice)
	shopMenuAction.send(userid)
def sendUtilityShopMenuActionSelect(userid, choice, shopMenuAction):
	steamid = getSteamid(userid)
	check = 0
	if choice == 'Buy':
		if humandata[steamid]['credits'] > utilityList[inventorySelection[steamid]]['cost']:
			choices = ('Slot1', 'Slot2')
			shopMenuAction = popuplib.easymenu('shopMenuAction_%s'%userid, '_popup_choice', utilityShopSlotSelect)
			shopMenuAction.settitle('Select a Slot')
			for choice in choices:
				shopMenuAction.addoption(choice, choice)
			shopMenuAction.send(userid)
		else:
			es.tell(userid, "#green",'Not enough Credits')
	elif choice == 'Description':
		es.tell(userid, "#green",utilityList[inventorySelection[steamid]]['description'])
def utilityShopSlotSelect(userid, choice, sendUtilityShopMenu):
	steamid = getSteamid(userid)
	if choice == 'Slot1':
		humandata[steamid]['utility1'] = inventorySelection[steamid]
		human().credits().remove(userid,utilityList[inventorySelection[steamid]]['cost'])
		es.tell(userid, "#green",'You have Purchased a ' + utilityList[inventorySelection[steamid]]['name'])
		try:
			shopCheck = 0
			count = count2 = 0
			newshop = {}
			global utilityShopMenuArray
			for item in utilityShopMenuArray:
				if shopCheck == 0:
					if utilityShopMenuArray[count] == inventorySelection[steamid]:
						shopCheck = 1
						es.dbgmsg(0,'Removed ' + utilityList[utilityShopMenuArray[count]]['name'] + ' From the shop')
					else:
						newshop[count2] = utilityShopMenuArray[count]
						count2 += 1
				else:
					newshop[count] = utilityShopMenuArray[count]
					count2 += 1
				count += 1
			utilityShopMenuArray = newshop
		except:
			es.dbgmsg(0,'Failed Removed ' + utilityList[utilityShopMenuArray[count]]['name'] + ' From the shop')
	elif choice == 'Slot2':
		humandata[steamid]['utility2'] = inventorySelection[steamid]
		human().credits().remove(userid,utilityList[inventorySelection[steamid]]['cost'])
		es.tell(userid, "#green",'You have Purchased a ' + utilityList[inventorySelection[steamid]]['name'])
		try:
			shopCheck = 0
			count = count2 = 0
			newshop = {}
			global utilityShopMenuArray
			for item in utilityShopMenuArray:
				if shopCheck == 0:
					if utilityShopMenuArray[count] == inventorySelection[steamid]:
						shopCheck = 1
						es.dbgmsg(0,'Removed ' + utilityList[utilityShopMenuArray[count]]['name'] + ' From the shop')
					else:
						newshop[count2] = utilityShopMenuArray[count]
						count2 += 1
				else:
					newshop[count] = utilityShopMenuArray[count]
					count2 += 1
				count += 1
			utilityShopMenuArray = newshop
		except:
			es.dbgmsg(0,'Failed Removed ' + utilityList[utilityShopMenuArray[count]]['name'] + ' From the shop')

#armor Shop	
def armorShopMenuCreate():
	global armorShopMenuArray
	armorShopMenuArray = {}
	x = 0
	while x <= 15:
		armorShopMenuArray[x] = random.randint(1,armorCount)
		x += 1
		
def armorShopMenuCMD():
	userid = es.getcmduserid()
	sendArmorShopMenu(userid)
	es.dbgmsg(0,'Sending Armor Shop Shop Menu')
def sendArmorShopMenu(userid):
	shopMenu = popuplib.easymenu('armorShopMenu', '_popup_choice', sendArmorShopMenuAction)
	shopMenu.settitle('Armor Shop')
	for number in armorShopMenuArray:
		shopMenu.addoption(armorShopMenuArray[number], armorList[armorShopMenuArray[number]]['name'] + ':' + str(armorList[armorShopMenuArray[number]]['cost']))
	popuplib.send('armorShopMenu', userid)
def sendArmorShopMenuAction(userid, choice, sendArmorShopMenu):
	steamid = getSteamid(userid)
	inventorySelection[steamid] = choice
	choices = ('Buy', 'Description')
	shopMenuAction = popuplib.easymenu('shopMenuAction_%s'%userid, '_popup_choice', sendArmorShopMenuActionSelect)
	shopMenuAction.settitle('Select an Action')
	for choice in choices:
		shopMenuAction.addoption(choice, choice)
	shopMenuAction.send(userid)
def sendArmorShopMenuActionSelect(userid, choice, shopMenuAction):
	steamid = getSteamid(userid)
	check = 0
	if choice == 'Buy':
		if humandata[steamid]['credits'] > armorList[inventorySelection[steamid]]['cost']:
			humandata[steamid]['armor'] = inventorySelection[steamid]
			human().credits().remove(userid,armorList[inventorySelection[steamid]]['cost'])
			es.tell(userid, "#green",'You have Purchased a ' + armorList[inventorySelection[steamid]]['name'])
			try:
				shopCheck = 0
				count = count2 = 0
				newshop = {}
				global armorShopMenuArray
				for item in armorShopMenuArray:
					if shopCheck == 0:
						if armorShopMenuArray[count] == inventorySelection[steamid]:
							shopCheck = 1
							es.dbgmsg(0,'Removed ' + armorList[armorShopMenuArray[count]]['name'] + ' From the shop')
						else:
							newshop[count2] = armorShopMenuArray[count]
							count2 += 1
					else:
						newshop[count] = armorShopMenuArray[count]
						count2 += 1
					count += 1
				armorShopMenuArray = newshop
			except:
				es.dbgmsg(0,'Failed Removed ' + utilityList[utilityShopMenuArray[count]]['name'] + ' From the shop')
		else:
			es.tell(userid, "#green",'Not enough Credits')
	elif choice == 'Description':
		es.tell(userid, "#green",armorList[inventorySelection[steamid]]['description'])
		
#Stats Menu
def statsMenuCMD():
	userid = es.getcmduserid()
	sendStatsMenu(userid,userid)
	es.dbgmsg(0,'Sending Stats Menu')
	
def sendStatsMenu(userid,target):
	steamid = getSteamid(userid)
	
	primary = secondary = u1Name = u2Name = armorName = hImp = cImp = lImp = 'None'
	HE = FB = SG = '0'
	HEm = FBm = SGm = 'None'
	
	if humandata[steamid]['primary'] != 0:
		primary = weaponlist[humandata[steamid]['gear'][humandata[steamid]['primary']]['weapon']]['name']
	if humandata[steamid]['secondary'] != 0:
		secondary = weaponlist[humandata[steamid]['gear'][humandata[steamid]['secondary']]['weapon']]['name']
	if humandata[steamid]['utility1'] != 0:
		u1Name = utilityList[humandata[steamid]['utility1']]['name']
	if humandata[steamid]['utility2'] != 0:
		u2Name = utilityList[humandata[steamid]['utility2']]['name']
	if humandata[steamid]['armor'] != 0:
		armorName = armorList[humandata[steamid]['armor']]['name']
	if humandata[steamid]['implants']['head'] != 0:
		doshit = 1
	if humandata[steamid]['implants']['chest'] != 0:
		doshit = 1
	if humandata[steamid]['implants']['legs'] != 0:
		doshit = 1
	
	if humandata[steamid]['flashNade'] != 0:
		FB = 'X'
	if humandata[steamid]['fragNade'] != 0:
		HE = 'X'
	if humandata[steamid]['smokeNade'] != 0:
		SG = 'X'
		
	if humandata[steamid]['flashMod'] != 0:
		FBm = 'X'
	if humandata[steamid]['fragMod'] != 0:
		HEm = nadeMods[humandata[steamid]['fragMod']]['name']
	if humandata[steamid]['smokeMod'] != 0:
		SGm = 'X'
	
	infoMenu = popuplib.create('infoMenu')
	infoMenu.addline('-----Weapons-----')
	infoMenu.addline('Primary Gun: ' + str(primary))
	infoMenu.addline('Secondary Gun: ' + str(secondary))
	infoMenu.addline('Frag:' + HE + ' Flash:' + FB + ' Smoke:' + SG)
	infoMenu.addline('Frag Mod:' + HEm)
	infoMenu.addline('Flash Mod:' + FBm)
	infoMenu.addline('Smoke Mod:' + SGm)
	infoMenu.addline('------Utility----')
	infoMenu.addline('Slot 1: ' + str(u1Name))
	infoMenu.addline('Slot 2: ' + str(u2Name))
	infoMenu.addline('Armor: ' + str(armorName))
	infoMenu.addline('------Implants---')
	infoMenu.addline('Head: ' + hImp)
	infoMenu.addline('Chest: ' + cImp)
	infoMenu.addline('Legs: ' + lImp)
	infoMenu.addline('------Stats------')
	infoMenu.addline('Credits: ' + str(humandata[steamid]['credits']))
	infoMenu.addline('Kills: ' + str(humandata[steamid]['kills']) + ' Deaths: ' + str(humandata[steamid]['deaths']))
	infoMenu.addline('Survived Rounds: ' + str(humandata[steamid]['roundsSurvived']))
	popuplib.send('infoMenu', target)
	es.dbgmsg(0,'Info Menu Created')
	
################################################################################
#						 													  #
#					 	         weaponlist                                   #
#																			  #
################################################################################

def genWeaponList():
	global inventorySelection
	global weaponlist
	global weaponCount
	inventorySelection = {}
	weaponlist = {}
	weaponlist = weaponDataBase.createWeapons()
	
	weaponCount = 0
	for item in weaponlist:
		weaponCount += 1
	
	
##################################################################################################
#EOF
##################################################################################################